/* Reset All

This plugin resets your HP, Money, Armor, Frags and Deaths.

HP = 100
Armor = 0
Money = 16000
Frags = 0
Deaths = 0
*/

#include <amxmodx>
#include <cstrike>
#include <fun>

#define PLUGIN "Reset All"
#define VERSION "1.1"
#define AUTHOR "HaLLoWeN"

// Message IDs vars
new g_msgScoreInfo

// CVAR pointers
new cvar_enabled, cvar_startmoney, cvar_buyzone, cvar_health, cvar_armor

// Player vars
new bool:g_allow_reset[33] // allow to reset all?

// Game vars
new g_maxplayers // max players counter

public plugin_init() {
	// Register
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	// ML Dictionary
	register_dictionary("reset-all.txt")
    
	// Events
	register_logevent("round_start", 2, "1=Round_Start")
    
	// Client commands
	register_clcmd("say /resetall", "reset_all")
	register_clcmd("say resetall", "reset_all")
	register_clcmd("say_team /resetall", "reset_all")
	register_clcmd("say_team resetall", "reset_all")
    
	// Message IDs
	g_msgScoreInfo = get_user_msgid("ScoreInfo")
    
	// CVARS - General
	cvar_enabled = register_cvar("sv_resetall", "1")
	
	// CVARS - Other
	cvar_startmoney = register_cvar("ra_get_money", "16000")  //amount of money
	cvar_buyzone = register_cvar("ra_only_buyzone", "1")      //command is only in buyzone?
	cvar_health = register_cvar("ra_get_hp", "100") 		 //amount of health
	cvar_armor = register_cvar("ra_get_armor", "0")           //amount of armor
    
	// Get Max Players
	g_maxplayers = get_maxplayers()
}

public round_start() {
    
	// set all players to allow reset command
	for(new id = 1; id <= g_maxplayers; id++) {
	g_allow_reset[id] = true
	}
}

public client_putinserver(id) {
	g_allow_reset[id] = true
	set_task(15.0, "connectmessage", id)
}

public reset_all(id) {
	// Plugin enables?
	if(!get_pcvar_num(cvar_enabled)) {
	client_print(id, print_chat, "[%L] %L", id, "PREFIX", id, "CMD_DISABLED")
	return
	}

	// Only Buyzone?
	if(get_pcvar_num(cvar_buyzone) && !cs_get_user_buyzone(id)) 
	{
	client_print(id, print_chat, "[%L] %L", id, "PREFIX", id, "NOT_BZ")
	return
	}
    
	// allow to reset?
	if(g_allow_reset[id]) {
	// set player money to ra_get_money
	cs_set_user_money(id, get_pcvar_num(cvar_startmoney))
	
	// set player health to ra_get_hp
	set_user_health(id, get_pcvar_num(cvar_health))
	
	// set player armor to ra_get_armor
	set_user_armor(id, get_pcvar_num(cvar_armor))
	
	// set player score
	set_user_frags_deaths(id, 0, 0)
        
	//Credits about plugin is display only when client type /resetall.
	client_print(id, print_chat, "[%L] %L", id, "PREFIX", id, "INFO", PLUGIN, AUTHOR, VERSION)
        
	g_allow_reset[id] = false
	}
    
	else
	client_print(id, print_chat, "[%L] %L", id, "PREFIX", id, "ONCE")
}

public connectmessage(id) {
	if(get_pcvar_num(cvar_enabled) && is_user_connected(id))
	client_print(id, print_chat, "[%L] %L", id, "PREFIX", id, "CMD")
}

set_user_frags_deaths(id, frags, deaths) {
	set_user_frags(id, frags)
	cs_set_user_deaths(id, deaths)
	
	message_begin(MSG_BROADCAST, g_msgScoreInfo)
	write_byte(id) // id
	write_short(frags) // frags
	write_short(deaths) // deaths
	write_short(0) // class?
	write_short(get_user_team(id)) // team
	message_end()
}  